config/routes.rb
Rails.application.routes.draw do
  root 'posts#index'
  resources :posts
  namespace :api do
    namespace :v1 do
      resources :posts, only: [:index]
    end
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/post.rb
class Post < ApplicationRecord
  PAGINATE = 10
end

app/controllers/api/v1/posts_controller.rb
class Api::V1::PostsController < ApiController
  before_action :set_last_post_id, only: [:index]

  def index
    @posts = Post.all.reverse_order.limit(Post::PAGINATE).where("id < ?", @last_post_id)
    render :json => @posts
  end

  private

  def set_last_post_id
    @last_post_id = params[:last_post_id].to_i
  end
end

app/controllers/api_controller.rb
class ApiController < ActionController::API
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/posts_controller.rb
class PostsController < ApplicationController
  before_action :set_post, only: [:show]

  def index
    if params[:last_post_id].nil?
      redirect_to posts_path(:last_post_id => Post.last.id + 1)
    end
    @posts = Post.all.reverse_order.where("id >= ?", params[:last_post_id].to_i - Post::PAGINATE)
  end

  def show
  end

  def new
    @post = Post.new
  end

  def create
    @post = Post.new(post_params)

    if @post.save
      redirect_to posts_path(:last_post_id => params[:last_post_id].nil? ? Post.last.id + 1 : params[:last_post_id])
    else
      render :new
    end
  end

  private

  def set_post
    @post = Post.find(params[:id])
  end

  def post_params
    params.require(:post).permit(:title, :description)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/posts_helper.rb
module PostsHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RorCoursorPagination</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body class="<%= controller_name + " " + action_name %>">
    <div class="container">
      <%= yield %>
    </div>
  </body>
</html>

app/views/posts/_form.html.erb
<%= form_with(model: post, local: true) do |form| %>
  <% if post.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(post.errors.count, "error") %> prohibited this post from being saved:</h2>

      <ul>
        <% post.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-group">
    <%= form.label :title %>
    <%= form.text_field :title, class: 'form-control' %>
  </div>

  <div class="form-group">
    <%= form.label :description %>
    <%= form.text_area :description, class: 'form-control' %>
  </div>

  <div class="actions">
    <%= form.submit class: 'btn btn-success' %>
  </div>
<% end %>

app/views/posts/index.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Posts', posts_path, class: 'h1'%>
<br>
<%= link_to 'New Post', new_post_path, class: 'btn btn-primary mb-3' %>
<div class="row">
  <div class="posts" id="postsList">
    <% @posts.each do |post| %>
      <div class="col-12 post" data-id="<%= post.id %>">
        <div class="card bg-light mb-3">
          <div class="card-header"><%= post.id %> <%= post.title %></div>
          <div class="card-body">
            <p class="card-text"><%= post.description %></p>
            <%= link_to 'Show', post, class: 'btn btn-success' %>
          </div>
        </div>
      </div>
    <% end %>
  </div>
</div>

app/views/posts/new.html.erb
<h1>New Post</h1>

<%= render 'form', post: @post %>

<%= link_to 'Back', url_for(:back), class: 'btn btn-primary mt-2' %>

app/views/posts/show.html.erb
<div class="row">
  <div class="col-12 my-3">
    <div class="card bg-light mb-3">
      <div class="card-header"><%= @post.title %></div>
      <div class="card-body">
        <p class="card-text"><%= @post.description %></p>
      </div>
    </div>
  </div>
</div>